
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何在tomcat启动时自动加载一个类 / 憋错料</title>

    <meta name="description" content="如何在tomcat启动时自动加载一个类 有时候在开发web应用的时候,需要tomcat启动后自动加载一个用户的类,执行一些初始化方法,如从数据库中加载业务字典到内存中,因此需要在tomcat启动时就自动加载一个类,或运行一个类的方法. 可以采用在WEB-INF/web.xml中添加一个监听程序(ServletContextListener配置项),步骤如下:1) 增加一个监听程序 MyServletContextListener.java, 实现javax.servlet.ServletContextListener接口 packag">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">如何在tomcat启动时自动加载一个类</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>有时候在开发web应用的时候，需要tomcat启动后自动加载一个用户的类，执行一些初始化方法，如从数据库中加载业务字典到内存中，因此需要在tomcat启动时就自动加载一个类，或运行一个类的方法。</p>
<p>可以采用在WEB-INF/web.xml中添加一个监听程序（ServletContextListener配置项），步骤如下：<br />1) 增加一个监听程序 MyServletContextListener.java， 实现javax.servlet.ServletContextListener接口</p>
<pre>package com.njupt.startup;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

public class MyServletContextListener implements ServletContextListener {

    @Override
    public void contextDestroyed(ServletContextEvent arg0) {
        // TODO Auto-generated method stub

    }

    @Override
    public void contextInitialized(ServletContextEvent arg0) {
        // TODO Auto-generated method stub
        System.out.println("加载业务字典");
        try {
            <strong>//加载数据字典的业务逻辑</strong>
        } catch (Exception e) {
            System.out.println("加载业务字典失败！");
            e.printStackTrace();
        }

    }

}</pre>
<p>2) 配置监听器web.xml：</p>
<pre>&lt;listener&gt;
　　&lt;listener-class&gt;com.njupt.startup.MyServletContextListener&lt;/listener-class&gt;
&lt;/listener&gt;</pre>
<p>注意：应用事件监听器程序是建立或修改servlet环境或会话对象时通知的类。它们是servlet规范的版本2.3中的新内容。注册一个监听程序涉及 在 web.xml的web-app元素内放置一个listener元素。虽然listener元素的结构很简单，但请不要忘记，必须正确地给出web- app元素内的子元素的次序。listener元素位于所有的servlet 元素之前以及所有filter-mapping元素之后。此外，因为应用生存期监听程序是serlvet规范的2.3版本中的新内容，所以必须使用 web.xml DTD的2.3或以后版本，而不是2.2版本，如下：</p>
<pre>&lt;web-app id="WebApp_ID" version="2.4"
xmlns="http://java.sun.com/xml/ns/j2ee"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://java.sun.com/xml/ns/j2ee http://java.sun.com/xml/ns/j2ee/web-app_2_4.xsd"&gt;
...
&lt;/web-app&gt;</pre>
<p>原文：<a href="http://www.javaranger.com/archives/215" rel="external nofollow noreferrer">http://www.javaranger.com/archives/215</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 05:30:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>如何在tomcat启动时自动加载一个类的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dPVAw0.html" rel="bookmark">tomcat启动时自动加载一个类&amp;&num;160&semi;MyServletContextListener</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目的: 我们知道在tomcat启动后,需要页面请求进行驱动来执行操作接而响应.我们希望在tomcat启动的时候能够自动运行一个后台线程,以处理我们需要的一些操作.因此需要tomcat启动时就自动加载一个类,或运行一个类的方法. 可以采用ServletContextListener. 方法: (1)编写一个监听类,实现javax.servlet.ServletContextListener接口. 1 import javax.servlet.ServletContextEvent; 2 impor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0d218z4.html" rel="bookmark">Tomcat启动时自动加载Servlet</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.想做一个服务启动时自动启动一不停止的获取订阅功能 2.之前是做一个Jsp页面请求servlet来触发方法 3.现在实现Tomcat启动时自动加载Servlet 1.Tomcat中启动Servlet时,只需要在Servlet所在的工程的配置文件web.xml中写成如下即可 &lt;!-- 自动启动订阅接口 --&gt; &lt;servlet&gt; &lt;servlet-name&gt;TimeServlet&lt;/servlet-name&gt; &lt;servlet-class&gt;ser			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4J2mQY4.html" rel="bookmark">胖客户端启动时自动加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				修改配置文件 &lt;!-- 系统启动时自动加载--&gt; &lt;extension point=&quot;org.eclipse.ui.startup&quot;&gt; &lt;startup class=&quot;xxxxx.ReminderAction&quot;/&gt; &lt;/extension&gt; 创建加载的类 public class ReminderAction implements IStartup { @Override public void earlyStartu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vvOGZ3.html" rel="bookmark">设置R启动时自动加载常用的包或函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在我前面的文章(http://www.cnblogs.com/homewch/p/5749850.html)中有提到R可以自定义启动环境,需要修改R安装文件中的ect文件夹下的配置文件Rprofile.site即可: Rprofile.site文件里,设置的内容包括默认编辑器,CRAN镜像选取,自动加载包等等. 如果你想要将常用的package和function在启动的时候让R自动加载,则可以将其写入到Rprofile.site文件的自定义函数里,重新启动R即可实现.在打开Rprofile.si			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lkPyEM.html" rel="bookmark">Tomcat启动时选择加载项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				到tomcat\conf\Catalina\localhost下新建文件:myapp.xml 内容如下: &lt;Context path=&quot;/myapp&quot; docBase=&quot;D:/myapp&quot; reloadable=&quot;true&quot;&gt; &lt;/Context&gt; 这样你就可以用.xml文件来控制要启动的应用了 可以在tomcat\conf\Catalina\localhost下再建个bak目录 把暂时不用的应用的.xml文件放到里边 因			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YggVO4.html" rel="bookmark">java web项目启动时自动加载自定义properties文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先创建一个类 public class ContextInitListener implements ServletContextListener 使得该类成为一个监听器.用于监听整个容器生命周期的,主要是初始化和销毁的. 类创建后要在web.xml配置文件中增加一个简单的监听器配置,即刚才我们定义的类. Xml代码 &lt;listener&gt; &lt;!-- lang: xml --&gt; &lt;description&gt;ServletContextListener&lt;/descri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXvY2a3.html" rel="bookmark">如何在tomcat启动时加载一个类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Tomcat启动时classloader加载顺序 Tomcat的class加载的优先顺序一览   1.最先是$JAVA_HOME/jre/lib/ext/下的jar文件.   2.环境变量CLASSPATH中的jar和class文件.   3.$CATALINA_HOME/common/classes下的class文件.   4.$CATALINA_HOME/commons/endorsed下的jar文件.   5.$CATALINA_HOME/commons/i18n下的jar文件.   6.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n6XDV0.html" rel="bookmark">Tomcat启动时自动运行某程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目需要和tmall实现长连接,接收tmall推送的Order消息,然后对消息进行逻辑处理. 目前写了一个servlet,实现了permit的验证,然后对tmall进行长连接操作,启动后,只要tomcat一直运行着,长连接就不会断掉.现在的需求是tomcat启动后我这个servlet自己就运行起来,不用我自己再去访问一下配置的servlet路径. 资料: http://www.cnblogs.com/Payne-Wang/archive/2013/04/01/loadOnTomcatStartu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YZvEr3.html" rel="bookmark">基于spring的web项目启动时预加载数据到ServletContext</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.要在web启动时预加载数据到ServletContext,实现方法有很多,一种比较简单的方案就是: 1)新建一个bean,定义其初始化方法: &lt;bean id=&quot;beanId&quot; init-method=&quot;初始化方法&quot; /&gt;或者使用@PostConstruct注解到初始化方法上面 2)获取ServletContext实例对象,如何获取呢? 方法1: @Autowired private ServletContext application; 方法2:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RBaJ70.html" rel="bookmark" class="title">OK6410视频VIDIOC&lowbar;QUERYBUF error 22&comma; Invalid argument</a>
					<div>
						试着去调一段代码,在OK6410上以Qt为界面显示出来,得到以下两个结果 1.VIDIOC_QUERYBUF error 22, Invalid argument 2.s3c-fimc: invali ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AdjWb3.html" rel="bookmark" class="title">第一周第三天日报</a>
					<div>
						姓名 段杰 时间 2016年6月29日 工作进展 今天进行了: 1)  服务端与客户端的建立和分离 2)  本地记录存取 3)  数据库重新设计 4)  讨论了接下来的增加功能 所遇问题 服务器的建立 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqBEw0.html" rel="bookmark" class="title">关于结对编程的一些问题</a>
					<div>
						前言 最近由于公司项目,有机会尝试结对编程(pair programming),实践了3个月,也有了自己的一些心得体会,本文以Martin.Fowler的&lt;结对编程模糊概念&gt;来展开叙述.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j7jvA3.html" rel="bookmark" class="title">文件管理NSFileManager</a>
					<div>
						p.p1 { margin: 0.0px 0.0px 0.0px 0.0px; font: 18.0px Menlo; color: #000000 } p.p2 { margin: 0.0px 0. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47Dg2kM.html" rel="bookmark" class="title">TestNG依赖测试</a>
					<div>
						有时候,你可能需要在一个特定的顺序调用方法在测试案例,或你想分享一些数据和方法之间的状态.TestNG支持这种依赖测试方法之间的显式依赖它支持声明.TestNG允许指定依赖,无论与否:使用属性depe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBe8YM.html" rel="bookmark" class="title">C&num;中字符串的常用方法</a>
					<div>
						1.查找某个字符或子字符串,  在指定字符串中首次出现的位置  IndexOf(char\string);//返回下标   返回-1,说明找不到   返回&gt;=0的数字,说明存在 2.截取字符串  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmYNgDM.html" rel="bookmark" class="title">JVM-垃圾回收</a>
					<div>
						1.垃圾回收如何判定 1.1引用计数法 引用计数法是给对象添加一个引用计数器,当有对该对象的引用时,计数器加1,引用失效时,计数减1,计数器为0时不能再使用.该对象可以被垃圾回收器回收,但是存在一个问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekjpZ4.html" rel="bookmark" class="title">Linux 进程退出后自动启动</a>
					<div>
						/********************************************************************** * Linux 进程退出后自动启动 * 说明: * 在系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3On8lG0.html" rel="bookmark" class="title">转：基于node的web开发框架Express入门--by ruanyifeng</a>
					<div>
						JavaScript 标准参考教程(alpha) 草稿二:Node.js Express框架 GitHub TOP Express框架 来自&lt;JavaScript 标准参考教程(alpha)&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QjE9lM.html" rel="bookmark" class="title">Egret Wing4&period;0&period;3  合并资源图片问题</a>
					<div>
						一 发布项目时,选择合并图片资源 选择合图大小 发布后,图片合并.随机了图片名字.  二  随机名的问题 当资源不变更的情况下,多次发布,每次发布后资源的图片随机名是不变的. 现在改变preload组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YqjeX0.html" rel="bookmark" class="title">asp&period;net  mvc中Controller向View传值方式总结</a>
					<div>
						http://www.cnblogs.com/gaopin/archive/2012/11/13/2767515.html http://www.cnblogs.com/a164266729/p/49 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvNGy3.html" rel="bookmark" class="title">C&num; websocket与html js实现文件发送与接收处理</a>
					<div>
						using System; using System.Collections.Generic; using System.Linq; using System.Text; using System.T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVQ1nQ4.html" rel="bookmark" class="title">Python开发【第四章】：Python函数剖析</a>
					<div>
						一.Python装饰器 定义:本质是函数(装饰其他函数),为其他函数添加附件功能的. 遵循原则:①不能修改被装饰函数的源代码 ②不能修改被装饰函数的调用方式 组成:装饰器由高阶函数+内嵌函数+闭包组成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQr1q0.html" rel="bookmark" class="title">HDU 1005 Number Sequence【多解，暴力打表，鸽巢原理】</a>
					<div>
						Number Sequence Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K77vm0.html" rel="bookmark" class="title">如何查看、备份电脑隐藏的恢复分区</a>
					<div>
						步骤: 1.用管理员身份打开CMD(快捷键:1. 同时按 win+x  2. 按 a  ),输入diskpart,回车enter. (或者 按 win+r   在运行中输入 diskpart  也行) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pG6Zo3.html" rel="bookmark" class="title">STM32 USB FS Core and USB OTG Core</a>
					<div>
						STM32 USB-FS-Device development kit Compatible with the STM32F102xx and STM32F103xx series, STM32 L1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OQAq7M.html" rel="bookmark" class="title">【原创】mac下为eclipse安装反编译插件</a>
					<div>
						1.http://jd.benow.ca/ 打开这个网站,找到 JD-Eclipse 选择其中一种方式,下载他到本地. 2.解压缩得到一些文件,文件夹.其中反编译要用到的有,“features”文件夹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AnDv5M.html" rel="bookmark" class="title">猫猫学IOS（二十六）UI之iOS抽屉效果小Demo</a>
					<div>
						猫猫分享,必须精品 素材代码地址:http://blog.csdn.net/u013357243/article/details/45305785 原创文章,欢迎转载.转载请注明:翟乃玉的博客 地址: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jwl2g3.html" rel="bookmark" class="title">SQL CRUD 简单查询</a>
					<div>
						identity 自增长 primary key 主键 unique 唯一键 not null 非空 references 外键(引用) 1.删除表 drop table Student 2.修改表  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l8zvP0.html" rel="bookmark" class="title">判断字符数加&period;&period;&period;</a>
					<div>
						这篇文章主要介绍了JS判断字符串长度的5个方法,并且区分中文和英文,需要的朋友可以参考下 目的:计算字符串长度(英文占1个字符,中文汉字占2个字符) 方法一: 代码如下: String.prototy ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
